//-------------------------------------------------------------------------------------
//	base
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
//	Phil le   13/01/2013
//-------------------------------------------------------------------------------------







//-------------------------------------------------------------------------------------
#ifndef main_h
#define main_h
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
//	definitions et constantes
//-------------------------------------------------------------------------------------

#define F_CPU 			16000000UL		//frequence quartz

#define SET_VA_max 		1		//VA_max
#define SET_VG2_max 	2		//VG2_max
#define SET_VG1_max 	3		//VG1_max
#define SET_VFIL_max 	4		//VFIL_max
#define SET_IA_max 		5		//IA_max
#define SET_IG2_max 	6		//IG2_max
#define SET_IG1_max 	7		//IG1_max
#define SET_PWA_max 	8		//PWA_max
#define SET_PWG2_max 	9		//PWG2_max
#define SET_PWG1_max 	10		//PWG1_max

#define SET_VG2_min 	11		//VG2_min
#define SET_VG1_min 	12		//VG1_min
#define SET_VFIL_min 	13		//VFIL_min

#define SET_VA 			14		//VA
#define SET_VG2 		15		//VG2
#define SET_VG1 		16		//VG1
#define SET_VFIL 		17		//VFIL

#define MESURE 			18		//MESURE

#define ncom 			19		//nombre de commandes possibles

#define mes_VA			1		//canal ADC de mesure
#define mes_VG1			2		//canal ADC de mesure
#define mes_VG2			3		//canal ADC de mesure
#define mes_IA			4		//canal ADC de mesure
#define mes_IG1			5		//canal ADC de mesure
#define mes_IG2			6		//canal ADC de mesure
#define mes_VFIL		7		//canal ADC de mesure

#define reg_VA			1		//port pour regler la tension
#define reg_VG1			2		//port pour regler la tension
#define reg_VG2			3		//port pour regler la tension
#define reg_VFIL		4		//port pour regler la tension

//-------------------------------------------------------------------------------------
//includes
//-------------------------------------------------------------------------------------

#include <avr/io.h>
#include</home/phil/ATMEL/atmel/avr/include/util/delay.h>
#include</home/phil/ATMEL/atmel/avr/include/util/twi.h>
#include</home/phil/ATMEL/atmel/avr/include/avr/interrupt.h>
#include</home/phil/ATMEL/avr-libc-1.4.4/doc/examples/demo/iocompat.h>
#include</home/phil/ATMEL/avr-libc-1.4.4/include/math.h>

//-------------------------------------------------------------------------------------
//variables globales
//-------------------------------------------------------------------------------------

//tableau de pointeur de fonctions
void (*pf[ncom])(float);

//VA_max
volatile float VA_max;

//VG2_max
volatile float VG2_max;

//VG1_max
volatile float VG1_max;

//VFIL_max
volatile float VFIL_max;

//IA_max
volatile float IA_max;

//IG2_max
volatile float IG2_max;

//IG1_max
volatile float IG1_max;

//PWA_max
volatile float PWA_max;

//PWG2_max
volatile float PWG2_max;

//PWG1_max
volatile float PWG1_max;

//VG2_min
volatile float VG2_min;

//VG1_min
volatile float VG1_min;

//VFIL_min
volatile float VFIL_min;

//VA
volatile float VA;

//VG2
volatile float VG2;

//VG1
volatile float VG1;

//VFIL
volatile float VFIL;



//-------------------------------------------------------------------------------------
//routines
//-------------------------------------------------------------------------------------

//main
int main(void);

//courant du tube 12ax7
uint8_t courant(float va,float vg,float *ia);

void fonc_void(float v);
void set_VA_max(float v);
void set_VG2_max(float v);
void set_VG1_max(float v);
void set_VFIL_max(float v);
void set_IA_max(float v);
void set_IG2_max(float v);
void set_IG1_max(float v);
void set_PWA_max(float v);
void set_PWG2_max(float v);
void set_PWG1_max(float v);
void set_VG2_min(float v);
void set_VG1_min(float v);
void set_VFIL_min(float v);
void set_VA(float v);
void set_VG2(float v);
void set_VG1(float v);
void set_VFIL(float v);

void mesure(float v);





//initialisation transmission rs232
void rs232_init(unsigned char baud,unsigned char isr_rx);

//reception
unsigned char rs232_rx_8(void);

//emission
void rs232_tx_8(unsigned char v);

//reception 16
uint16_t rs232_rx_16(void);

//emission 16
void rs232_tx_16(uint16_t v);

//reception 32
float rs232_rx_32(void);

//emission 32
void rs232_tx_32(float v);

//-------------------------------------------------------------------------------------
#endif
//-------------------------------------------------------------------------------------
